# include <stdio.h>
# include <math.h>

const double a = -2.0;
const double b =  2.0;

/** f(x) **/
double f(double x)
{
    return x *sin(x*x);
}

/** real derivative **/
double fp(double x)
{
    return sin(x*x)+2.0*x*x*cos(x*x);
}


double finite1(double x)
{
    const double h=1e-6;
    return (f(x+h)-f(x))/h;
}

double dmax(double a,double b)
{
    return a>b?a:b;
}

double finite2(double x)
{
    double h = pow(1e-18,1.0/3.0)*dmax(1.0,fabs(x));
    return (f(x+h)-f(x-h))/(2.0*h);
}
void printDerivatives()
{
    double x;
    int npoints = 20;
    for(x=a;x<=b;x+=(b-a)/npoints)
    {
        double fx = f(x);
        double fpx = fp(x);
        double f1 = finite1(x);
        double f2 = finite2(x);
        printf("%10.5lf %20.10lf %20.10lf %20.10lf\n",
               x,fpx,f1,f2);
    }
}

int main()
{
    printDerivatives();
    return 0;
}
